ScriptName ewm_handlemodbase extends Quest hidden
{EasyWheelMenu Mod handler base script}


;
; PROPERTIES
;
Bool Property HasSpells = false AUTO  ;; --> ::HasSpells_var
{Set to true if at least one function is used to replace a spell.}

Bool Property isManuallyDisabled = false AUTO hidden  ;; --> ::isManuallyDisabled_var

Bool[] Property FCT_LST_CONDITION AUTO hidden  ;; --> ::FCT_LST_CONDITION_var

Int Property isManuallyDisabledFlag hidden
	Int Function GET()
		IF isManuallyDisabled
			RETURN 1
		ENDIF
		RETURN 0
	EndFunction
EndProperty

String Property AddOnQuest = "" AUTO  ;; --> ::AddOnQuest_var
{Must be set to the exact EditorID of the quest this script is attached to !}

String Property PluginName = "" AUTO  ;; --> ::PluginName_var
{Name for this handler (used for the display in the MCM)}

String[] Property FCT_LST_DEFAULT AUTO  ;; --> ::FCT_LST_DEFAULT_var
{List of functions available for this handler.}

String[] Property FunctionsForMenu hidden
	String[] Function GET()
		Int i = FCT_LST_DEFAULT.length
		Int j = 0
		String[] myList = utility.CreateStringArray(i, "")
		WHILE i > 0
			i = i - 1
			IF self.GetFunctionCondition(i)
				myList[j] = "$" + (FCT_LST_DEFAULT[i])
				j = j + 1
			ENDIF
		ENDWHILE
		RETURN myList
	EndFunction
EndProperty

;AUTO State 

String Function GetFctRatio()
	RETURN ((ewm_util.StrCount(self.FunctionsForMenu)) + "/") + (FCT_LST_DEFAULT.length)
EndFunction

Function HideMySpells(Actor PlayerRef, String[] userSelection)
	IF !HasSpells || !easywheelapi.bHideSpells()
		RETURN NONE
	ENDIF
	Int i = FCT_LST_DEFAULT.length
	WHILE i > 0
		i = i - 1
		IF (userSelection.find(FCT_LST_DEFAULT[i], 0)) >= 0
			Spell mySpell = self.GetFunctionSpell(i)
			IF mySpell
			ENDIF
		ENDIF
	ENDWHILE
EndFunction

Int Function HasFunction(String functionName)
	RETURN FCT_LST_DEFAULT.find(functionName, 0)
EndFunction

Function OnHandlerInit()
EndFunction

Function RegisterFunction(Int functionIndex)
	IF self.GetFunctionCondition(functionIndex)
		String functionName = FCT_LST_DEFAULT[functionIndex]
		easywheelapi.AddFunction(functionName)
		self.RegisterForModEvent("EWM_" + functionName, "On" + functionName)
	ENDIF
EndFunction

Function OnInit()
	IF AddOnQuest != ""
		self.reinitialize()
	ENDIF
EndFunction

Bool Function GetFunctionConditionbyName(String functionName)
	Int i = self.HasFunction(functionName)
	IF i >= 0
		RETURN self.GetFunctionCondition(i)
	ELSE
		RETURN false
	ENDIF
EndFunction

Function OnEWMPluginCkeck()
	debug.Trace("[EasyWheel] Registering plugin : " + PluginName + " with " + AddOnQuest, 0)
	easywheelapi.EnableHandler(AddOnQuest, "")
EndFunction

Function ShowMySpells(Actor PlayerRef)
	IF !(HasSpells)
		RETURN NONE
	ENDIF
	Int i = FCT_LST_DEFAULT.length
	WHILE i > 0
		i = i - 1
		IF self.GetFunctionCondition(i)
			Spell mySpell = self.GetFunctionSpell(i)
			IF mySpell
			ENDIF
		ENDIF
	ENDWHILE
EndFunction

Int Function GetHandlerIndex()
	formlist Handlers = easywheelapi.GetHandlers()
	RETURN Handlers.Find((self as Quest) as form)
EndFunction

Spell Function GetFunctionSpell(Int functionIndex)
	RETURN NONE
EndFunction

Function RegisterFunctions()
	Int i = FCT_LST_DEFAULT.length
	WHILE i > 0
		i = i - 1
		self.RegisterFunction(i)
	ENDWHILE
EndFunction


State handleron

	Function onBeginState()
		debug.Trace("[EasyWheel] (handler on) " + AddOnQuest)
		formlist Handlers = easywheelapi.GetHandlers()
		Handlers.addForm((self as Quest) as form)
		FCT_LST_CONDITION = utility.CreateBoolArray(FCT_LST_DEFAULT.length, true)
		reinitialize()
		self.OnHandlerInit()
	EndFunction

	Function reinitialize()
		debug.Trace("[EasyWheel] Reinitializing (handler on) " + AddOnQuest)
		self.RegisterForModEvent("EWM_PluginCheck", "OnEWMPluginCkeck")
		self.RegisterForModEvent("EWM_ShowHandlerStatusEvent", "OnShowStatus")
		self.RegisterFunctions()
	EndFunction
	
	Bool Function GetFunctionCondition(Int functionIndex)
		RETURN true
	EndFunction

EndState

auto State handleroff

	Function onBeginState()
		debug.Trace("[EasyWheel] (handler off) " + AddOnQuest)
		formlist Handlers = easywheelapi.GetHandlers()
		Handlers.RemoveAddedForm((self as Quest) as form)
		easywheelapi.RemoveFunctions(FCT_LST_DEFAULT)
		self.UnregisterForAllModEvents()
	EndFunction

	Function reinitialize()
		debug.Trace("[EasyWheel] Reinitializing (handler off) " + AddOnQuest)
		self.RegisterForModEvent("EWM_PluginCheck", "OnEWMPluginCkeck")
	EndFunction

	Bool Function GetFunctionCondition(Int functionIndex)
		RETURN false
	EndFunction

EndState


Bool Function GetFunctionCondition(Int functionIndex)
	RETURN false
EndFunction

Function reinitialize()
	debug.Trace("[EasyWheel] Reinitializing (handler off) " + AddOnQuest)
	self.RegisterForModEvent("EWM_PluginCheck", "OnEWMPluginCkeck")
EndFunction

